//future.cpp
#include <allegro.h>
#include <iostream>
#include <fstream>
#include "future.h"
#include "fight.h"

using std::ifstream;

//variables
int** futuremap;
int** futurecollide;
int fmap_width, fmap_height;
int** fforestmap;
int** fforestcollide;
int fforestmap_width, fforestmap_height;
int** fforestmap2;
int** fforestcollide2;
int fforestmap_width2, fforestmap_height2;
bool backtothepast = false;



static void load_file()
{
	ifstream file("future.txt");
	if(!file.good())
	{
		allegro_message("Couldn't read future.bmp");
	}
	file >> fmap_width >> fmap_height;
	
	futuremap = new int* [fmap_height];
	for(int i = 0; i < fmap_height; i++)
      futuremap[i] = new int [fmap_width];
   for(int y = 0; y < fmap_height; y++)
	{
		for(int x = 0; x < fmap_width; x++)
    	{
        	file >> futuremap[y][x];
      }
   }  
	 
   futurecollide = new int * [fmap_height];
   for(int i = 0; i < fmap_height; i++)
      futurecollide[i] = new int [fmap_width];
   for(int y = 0; y < fmap_height; y++)
	{
		for(int x = 0; x < fmap_width; x++)
    	{
        	file >> futurecollide[y][x];
      }
   }  
   
	file >> fforestmap_width >> fforestmap_height;
	
	fforestmap = new int* [fforestmap_height];
	for(int i = 0; i < fforestmap_height; i++)
      fforestmap[i] = new int [fforestmap_width];
   for(int y = 0; y < fforestmap_height; y++)
	{
		for(int x = 0; x < fforestmap_width; x++)
    	{
        	file >> fforestmap[y][x];
      }
   }  
	 
   fforestcollide = new int * [fforestmap_height];
   for(int i = 0; i < fforestmap_height; i++)
      fforestcollide[i] = new int [fforestmap_width];
   for(int y = 0; y < fforestmap_height; y++)
	{
		for(int x = 0; x < fforestmap_width; x++)
    	{
        	file >> fforestcollide[y][x];
      }
   }    
	
	file >> fforestmap_width2 >> fforestmap_height2;
	
	fforestmap2 = new int* [fforestmap_height2];
	for(int i = 0; i < fforestmap_height2; i++)
      fforestmap2[i] = new int [fforestmap_width2];
   for(int y = 0; y < fforestmap_height2; y++)
	{
		for(int x = 0; x < fforestmap_width2; x++)
    	{
        	file >> fforestmap2[y][x];
      }
   }  
	 
   fforestcollide2 = new int * [fforestmap_height2];
   for(int i = 0; i < fforestmap_height2; i++)
      fforestcollide2[i] = new int [fforestmap_width2];
   for(int y = 0; y < fforestmap_height2; y++)
	{
		for(int x = 0; x < fforestmap_width2; x++)
    	{
        	file >> fforestcollide2[y][x];
      }
   }    
}

static void unload_file()
{
	for(int i = 0; i < fforestmap_height; i++)
   	delete [] fforestmap[i];
	for(int i = 0; i < fforestmap_height; i++)
   	delete [] fforestcollide[i];
	for(int i = 0; i < fmap_height; i++)
   	delete [] futuremap[i];
	for(int i = 0; i < fmap_height; i++)
   	delete [] futurecollide[i];
	for(int i = 0; i < fforestmap_height2; i++)
   	delete [] fforestmap2[i];
	for(int i = 0; i < fforestmap_height2; i++)
   	delete [] fforestcollide2[i];
}

static void blit_tiles(BITMAP* to, int sx, int sy, int dx, int dy, int w, int h)
{
	if(themapweareon == 3)
	{
		int tile_left = sx / TILE_W, tile_top = sy / TILE_H;
		if(tile_left < 0)
			tile_left = 0;
		if(tile_top < 0)
			tile_top = 0;
		int tile_right = w / TILE_W + tile_left - 1, tile_bottom = h / TILE_H + tile_top + 1;
		if(tile_right > fmap_width)
			tile_right = fmap_width;
		if(tile_bottom > fmap_height)
			tile_bottom = fmap_height;
		sx = -sx + tile_left * TILE_W + dx;
		sy = -sy + tile_top * TILE_H + dy;	
		for(int y = tile_top; y < tile_bottom; y++, sy += TILE_H)
		{
			for(int x = tile_left, temp_sx = sx; x < tile_right; x++, temp_sx += TILE_W)
			{
					blit(tilemap, to, (futuremap[y][x] % 10) * TILE_W, futuremap[y][x] / 10 * TILE_H, temp_sx, sy, TILE_W, TILE_H);
			}
		}
	}
	if(themapweareon == 4)
	{
		int tile_left = sx / TILE_W, tile_top = sy / TILE_H;
		if(tile_left < 0)
			tile_left = 0;
		if(tile_top < 0)
			tile_top = 0;
		int tile_right = w / TILE_W + tile_left - 1, tile_bottom = h / TILE_H + tile_top + 1;
		if(tile_right > fforestmap_width)
			tile_right = fforestmap_width;
		if(tile_bottom > fforestmap_height)
			tile_bottom = fforestmap_height;
		sx = -sx + tile_left * TILE_W + dx;
		sy = -sy + tile_top * TILE_H + dy;	
		for(int y = tile_top; y < tile_bottom; y++, sy += TILE_H)
		{
			for(int x = tile_left, temp_sx = sx; x < tile_right; x++, temp_sx += TILE_W)
			{
					blit(tilemap, to, (fforestmap[y][x] % 10) * TILE_W, fforestmap[y][x] / 10 * TILE_H, temp_sx, sy, TILE_W, TILE_H);
			}
		}
	}	
	if(themapweareon == 5)
	{
		int tile_left = sx / TILE_W, tile_top = sy / TILE_H;
		if(tile_left < 0)
			tile_left = 0;
		if(tile_top < 0)
			tile_top = 0;
		int tile_right = w / TILE_W + tile_left - 1, tile_bottom = h / TILE_H + tile_top + 1;
		if(tile_right > fforestmap_width2)
			tile_right = fforestmap_width2;
		if(tile_bottom > fforestmap_height2)
			tile_bottom = fforestmap_height2;
		sx = -sx + tile_left * TILE_W + dx;
		sy = -sy + tile_top * TILE_H + dy;	
		for(int y = tile_top; y < tile_bottom; y++, sy += TILE_H)
		{
			for(int x = tile_left, temp_sx = sx; x < tile_right; x++, temp_sx += TILE_W)
			{
					blit(tilemap, to, (fforestmap2[y][x] % 10) * TILE_W, fforestmap2[y][x] / 10 * TILE_H, temp_sx, sy, TILE_W, TILE_H);
			}
		}
	}
}

static void draw()
{
	int tlx = camerax - SCREEN_W / 2, tly = cameray - SCREEN_H / 2;
	clear(buffer);
	blit_tiles(buffer, tlx, tly, 0, 0, SCREEN_W + 32, SCREEN_H + 32);
	blit_tiles(buffer, tlx, tly, 0, 0, SCREEN_W + 64, SCREEN_H + 32);
	if(standing)
	{
		switch(direction)
		{
			case 4: masked_blit(maincharacter, buffer, 29, 104, x - tlx, y - tly, 15, 24); break;
			case 6: masked_blit(maincharacter, buffer, 29, 40, x - tlx, y - tly, 15, 24); break;
			case 8: masked_blit(maincharacter, buffer, 28, 8, x - tlx,  y - tly, 16, 24); break;
			default: masked_blit(maincharacter, buffer, 28, 72, x - tlx, y - tly, 16, 24); break;
		}
	}
	else switch(direction)
	{
		case 4:
			switch(count / 6 % 3)
			{
				case 0: masked_blit(maincharacter, buffer, 4, 104, x - tlx, y - tly, 15, 24); break;
				case 1: masked_blit(maincharacter, buffer, 29, 104, x - tlx, y - tly, 15, 24); break;
				case 2: masked_blit(maincharacter, buffer, 53, 104, x - tlx, y - tly, 15, 24); break;
			}
			break;
		case 6:
			switch(count / 6 % 3)
			{
				case 0: masked_blit(maincharacter, buffer, 4, 40, x - tlx, y - tly, 15, 24); break;
				case 1: masked_blit(maincharacter, buffer, 29, 40, x - tlx, y - tly, 15, 24); break;
				case 2: masked_blit(maincharacter, buffer, 53, 40, x - tlx, y - tly, 15, 24); break;
				}
			break;
		case 8:
			switch(count / 6 % 3)
			{
				case 0: masked_blit(maincharacter, buffer, 4, 8, x - tlx, y - tly, 15, 24); break;
				case 1: masked_blit(maincharacter, buffer, 28, 8, x - tlx,  y - tly, 16, 24); break;
				case 2: masked_blit(maincharacter, buffer, 53, 8, x - tlx, y - tly, 15, 24); break;
			}
			break;
		default:
			switch(count / 6 % 3)
			{
				case 0: masked_blit(maincharacter, buffer, 4, 72, x - tlx, y - tly, 15, 24); break;
				case 1: masked_blit(maincharacter, buffer, 28, 72, x - tlx, y - tly, 16, 24); break;
				case 2: masked_blit(maincharacter, buffer, 53, 72, x - tlx, y - tly, 15, 24); break;
			}
			break;
	}
	vsync();
	blit(buffer, screen, 0, 0, 0, 0, 800, 600);
}

static void logic()
{	if(key[KEY_LEFT])
	{
		x -= 7;
		standing = false;
		count ++;
		direction = 4;
		if(themapweareon == 3)
		{
			if(futurecollide[y / TILE_H][x / TILE_W] == 8)
			{
				x = 3166;
				y = 3430;
			}
			if(futurecollide[y / TILE_H][x / TILE_W] == 1 || futurecollide[(y + 24) / TILE_H][x / TILE_W] == 1 )
				x = oldx;
		}
		if(themapweareon == 4)
		{
			if(fforestcollide[y / TILE_H][x / TILE_W] == 1 || fforestcollide[(y + 24) / TILE_H][x / TILE_W] == 1 )
				x = oldx;
			if(fforestcollide[y / TILE_H][x / TILE_W] == 3)
			{
				themapweareon = 3;
				x = 2500;
				y = 3920;
				return;
			}
		}
		if(themapweareon == 5)
		{
			if(fforestcollide2[y / TILE_H][x / TILE_W] == 4) 
			{
				backtothepast = true;
			}
		}
		if(count % 5 == 0)
		{	
			randomencounter =  (rand() % 100) + 1;
			if(randomencounter == 42)
			{
				fighting = true;
			}
		}
	}

	else if(key[KEY_RIGHT])
	{
		x += 7;
		standing = false;
		count ++;
		direction = 6;
		if(themapweareon == 3)
		{
			if(futurecollide[y / TILE_H][x / TILE_W] == 3) 
			{
				themapweareon = 4;
		  		y = 320;
		  		x = 34;
		  		return;
		  	}
			if(futurecollide[y / TILE_H][x / TILE_W] == 5)
			{
				x = 32;
				y = 3320;
			}
			
			if(futurecollide[y / TILE_H][(x + 16) / TILE_W] == 1 || futurecollide[(y + 24) / TILE_H][(x + 16) / TILE_W] == 1)
				x = oldx;
		}		
		if(themapweareon == 4)
		{
			if(fforestcollide[y / TILE_H][(x + 16) / TILE_W] == 1 || fforestcollide[(y + 24) / TILE_H][(x + 16) / TILE_W] == 1 )
				x = oldx;
			if(fforestcollide[y /TILE_H][(x + 16) / TILE_W] == 5)
			{
				x = 34;
				y = 320;
			}
		}
		if(themapweareon == 5)
		{
			if(fforestcollide2[y / TILE_H][x / TILE_W] == 4) 
			{
				backtothepast = true;
			}
		}
		if(count % 5 == 0)
		{	
			randomencounter =  (rand() % 100) + 1;
			if(randomencounter == 42)
			{
				fighting = true;
			}
		}
	}
	else if(key[KEY_UP])
	{
		y -= 7;
		standing = false;
		count ++;
		direction = 8;
		if(themapweareon == 3)
		{
			if(futurecollide[y / TILE_H][x / TILE_W] == 6)
			{
				y = 3136;
				x = 624;
			}
			if(futurecollide[y / TILE_H][x / TILE_W] == 7)
			{
				themapweareon = 5;
				x = 448;
				y = 610;
			}
			if(futurecollide[y / TILE_H][(x + 16) / TILE_W] == 1 || futurecollide[y / TILE_H][x / TILE_W] == 1)
				y = oldy;
		}		
		if(themapweareon == 4)
		{
			if(fforestcollide[y / TILE_H][x / TILE_W] == 1 || fforestcollide[y / TILE_H][(x + 16) / TILE_W] == 1 )
				x = oldx;
		}
		if(themapweareon == 5)
		{
			if(fforestcollide2[y / TILE_H][x / TILE_W] == 4) 
			{
				backtothepast = true;
			}
		}
		if(count % 5 == 0)
		{	
			randomencounter =  (rand() % 100) + 1;
			if(randomencounter == 42)
			{
				fighting = true;
			}
		}
	}
	else if(key[KEY_DOWN])
	{
		y += 7;
		standing = false;
		count ++;
		direction = 2;
		if(themapweareon == 3)
		{
			if(futurecollide[y / TILE_H][x / TILE_W] == 7)
			{
				x = 604;
				y = 34;
			}
			if(futurecollide[(y + 24) / TILE_H][x / TILE_W] == 1 || futurecollide[(y + 24) / TILE_H][(x + 16) / TILE_W] == 1)
				y = oldy;
		}		
		if(themapweareon == 4)
		{
			if(fforestcollide[(y + 24) / TILE_H][(x + 16) / TILE_W] == 1 || fforestcollide[(y + 24) / TILE_H][x / TILE_W] == 1 )
				y = oldy;
		}
		if(themapweareon == 5)
		{
			if(fforestcollide2[y / TILE_H][x / TILE_W] == 3)
			{
				themapweareon = 3;
				x = 2592;
				y = 448;
			}
			if(fforestcollide2[y / TILE_H][x / TILE_W] == 4) 
			{
				backtothepast = true;
			}
		}
		if(count % 5 == 0)
		{	
			randomencounter =  (rand() % 100) + 1;
			if(randomencounter == 42)
			{
				fighting = true;
			}
		}
	}
	else
	{
		standing = true;
		count = 0;
	}
	oldx = x;
	oldy = y;
	camerax = x;
	cameray = y;
}

static void menu()
{
	clear(screen);
	while(atmenu)
	{
		textprintf(screen, font, 0,  0, -1,"1. Items");
		textprintf(screen, font, 0, 10, -1,"2. Status");
		textprintf(screen, font, 0, 20, -1,"3. Equipment");
		textprintf(screen, font, 0, 30, -1,"4. Monster List");
		textprintf(screen, font, 0, 40, -1,"5. Back to Game");
		textprintf(screen, font, 0, 50, -1,"6. Exit Game");
		textprintf(screen, font, 0, 60, -1,"Press 7 to go back from any sub-menu");
		if(key[KEY_1])
		{
			clear(screen);
			while(!key[KEY_7])
			{
				textprintf(screen, font, 0, 0, -1,"Items is incomplete");
				textprintf(screen, font, 0, 10, -1,"Press 7 to go back");
				textprintf(screen, font, 10, 10, -1, "-`````````````````````````````````````````````````````````````````````````````````````````````````."); 
				textprintf(screen, font, 10, 20, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 30, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 40, -1, ".                                                                         `-                      . ");
				textprintf(screen, font, 10, 50, -1, ".                                                                        +Nd                      . ");
				textprintf(screen, font, 10, 60, -1, ".                                                                 `--    :MM`  `/o:               . ");
				textprintf(screen, font, 10, 70, -1, ".                                                                 sNh    `MM/ `dMMMs              . ");
				textprintf(screen, font, 10, 80, -1, ".                                                                 +MN`    dMs oMNyMM:             . ");
				textprintf(screen, font, 10, 90, -1, ".                                                      `:o        .MM/yd/ sMm hMs hMh             . ");
				textprintf(screen, font, 10, 100, -1, ".                                                   -o:-MM.        mMNMMM::MM.hMhyNMM`            . ");
				textprintf(screen, font, 10, 110, -1, ".                                                   hMy`NM+  -sdm/ yMMNNMd`MM/sMMNds:             . ");
				textprintf(screen, font, 10, 120, -1, ".                                                   oms hMy -NMMMN./MM//MM-dMs/MM:`+s-            . ");
				textprintf(screen, font, 10, 130, -1, ".                                                   `-/`oMN sMN/mMo.MM: NM+oMm`mMhoMM.            . ");
				textprintf(screen, font, 10, 140, -1, ".                                               `..  mM+-MM.+h+-mMd mMs hMs:MM./MMMMy             . ");
				textprintf(screen, font, 10, 150, -1, ".                               `-+/          `omNNo hMy`NM+ `+NNMM`yMN-mMy`NM/ :hy/`             . ");
				textprintf(screen, font, 10, 160, -1, ".                               :NMm`      /y:+MMNMN.oMN hMy oMm:MM:/MMNMMo hd/                   . ");
				textprintf(screen, font, 10, 170, -1, ".                               :MMMo `:s. NM:hMh.NMo-MM.oMN mMo`MMs.MMdMm. ``                    . ");
				textprintf(screen, font, 10, 180, -1, ".                       o       :MMMN``mMs mM:/+:+NMh NM+-MM-dMdyMMm`hh--.                        . ");
				textprintf(screen, font, 10, 190, -1, ".                      :N-      :MNNMs +MN.dM: .hMmMN`hMy NM++MMMsho``                            . ");
				textprintf(screen, font, 10, 200, -1, ".            `         dMo`     :MNoMN. dModM: dMh-MM:+MN hMh +h+`                                . ");
				textprintf(screen, font, 10, 210, -1, ".          -yd`        hMmd`    :MM`NMs :MNdM- NM/-MMo-MM-/y:                                     . ");
				textprintf(screen, font, 10, 220, -1, ".     `:o` :MM-   `-. .NMMM-    -MM.yMN. hMMM- dMmmNMd`y+`                                        . ");
				textprintf(screen, font, 10, 230, -1, ".     /MMy `NMo  :dNm+`NMMm-    -MMmMMMy -MMM- /NMN:+-                                            . ");
				textprintf(screen, font, 10, 240, -1, ".     .MMM+ hMh `NMMMM/+NMo     -MMMMMMM- yMM.  :+-                                               . ");
				textprintf(screen, font, 10, 250, -1, ".      mMMN:oMN`:MM/dMm yMd     -MMmy+MMh .ds`                                                    . ");
				textprintf(screen, font, 10, 260, -1, ".      yMMMm/MM:+MN -MM-/MN`    -MM:  ymy`                                                        . ");
				textprintf(screen, font, 10, 270, -1, ".      /MMMMdMMo/MM` NM+.MMo:   -MN:  ``                                                          . ");
				textprintf(screen, font, 10, 280, -1, ".      .MMhMMMMd.MM: mMo dMMh   .o:`                                                              . ");
				textprintf(screen, font, 10, 290, -1, ".       mMysMMMN`dMm/NM/ /NMm                                                                     . ");
				textprintf(screen, font, 10, 300, -1, ".       yMm`dMMM:-NMMMN`  ::`                                                                     . ");
				textprintf(screen, font, 10, 310, -1, ".       /MM..mMMo /mNm:                                                                           . ");
				textprintf(screen, font, 10, 320, -1, ".       .MM/ :NMh  `.                                                                             . ");
				textprintf(screen, font, 10, 330, -1, ".        mMy  /:`                                                                                 . ");
				textprintf(screen, font, 10, 340, -1, ".        os:                                                                                      . ");
				textprintf(screen, font, 10, 350, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 360, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 370, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 380, -1, "``````````````````````````````````````````````````````````````````````````````````````````````````` ");
			}
			clear(screen);
		}
		if(key[KEY_2])
		{
			clear(screen);
			while(!key[KEY_7])
			{
				masked_blit(maincharacter, screen, 28, 72, 0, 0, 16, 24);
				textprintf(screen, font, 0, 30, -1,"Name: Christopher");
				textprintf(screen, font, 0, 40, -1,"Level: %d", level);
				if(!fought)
					textprintf(screen, font, 0, 50, -1,"Hp: You'll find out after your first battle. Okay?");
				if(fought)
					textprintf(screen, font, 0, 50, -1,"Hp: %d", hp);
				textprintf(screen, font, 0, 60, -1,"Hometown: Unknown");
				textprintf(screen, font, 0, 70, -1,"Age: Old");
				textprintf(screen, font, 0, 80, -1,"Occupation: Hobo");
				textprintf(screen, font, 0, 90, -1,"Likes: Food, money, women, and sleep");
				textprintf(screen, font, 0, 100, -1,"Dislikes: People who ignore him, not getting any sleep, and being poor");
				textprintf(screen, font, 0, 110, -1,"Bio:Not much know about his youth. Travels the world in search of riches.");				
			}
			clear(screen);
		}
		if(key[KEY_3])
		{
			clear(screen);
			while(!key[KEY_7])
			{
				textprintf(screen, font, 0, 0, -1,"Can't have equipment without items, eh?");
				textprintf(screen, font, 0, 10, -1,"Press 7 to go back");
				textprintf(screen, font, 10, 10, -1, "-`````````````````````````````````````````````````````````````````````````````````````````````````."); 
				textprintf(screen, font, 10, 20, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 30, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 40, -1, ".                                                                         `-                      . ");
				textprintf(screen, font, 10, 50, -1, ".                                                                        +Nd                      . ");
				textprintf(screen, font, 10, 60, -1, ".                                                                 `--    :MM`  `/o:               . ");
				textprintf(screen, font, 10, 70, -1, ".                                                                 sNh    `MM/ `dMMMs              . ");
				textprintf(screen, font, 10, 80, -1, ".                                                                 +MN`    dMs oMNyMM:             . ");
				textprintf(screen, font, 10, 90, -1, ".                                                      `:o        .MM/yd/ sMm hMs hMh             . ");
				textprintf(screen, font, 10, 100, -1, ".                                                   -o:-MM.        mMNMMM::MM.hMhyNMM`            . ");
				textprintf(screen, font, 10, 110, -1, ".                                                   hMy`NM+  -sdm/ yMMNNMd`MM/sMMNds:             . ");
				textprintf(screen, font, 10, 120, -1, ".                                                   oms hMy -NMMMN./MM//MM-dMs/MM:`+s-            . ");
				textprintf(screen, font, 10, 130, -1, ".                                                   `-/`oMN sMN/mMo.MM: NM+oMm`mMhoMM.            . ");
				textprintf(screen, font, 10, 140, -1, ".                                               `..  mM+-MM.+h+-mMd mMs hMs:MM./MMMMy             . ");
				textprintf(screen, font, 10, 150, -1, ".                               `-+/          `omNNo hMy`NM+ `+NNMM`yMN-mMy`NM/ :hy/`             . ");
				textprintf(screen, font, 10, 160, -1, ".                               :NMm`      /y:+MMNMN.oMN hMy oMm:MM:/MMNMMo hd/                   . ");
				textprintf(screen, font, 10, 170, -1, ".                               :MMMo `:s. NM:hMh.NMo-MM.oMN mMo`MMs.MMdMm. ``                    . ");
				textprintf(screen, font, 10, 180, -1, ".                       o       :MMMN``mMs mM:/+:+NMh NM+-MM-dMdyMMm`hh--.                        . ");
				textprintf(screen, font, 10, 190, -1, ".                      :N-      :MNNMs +MN.dM: .hMmMN`hMy NM++MMMsho``                            . ");
				textprintf(screen, font, 10, 200, -1, ".            `         dMo`     :MNoMN. dModM: dMh-MM:+MN hMh +h+`                                . ");
				textprintf(screen, font, 10, 210, -1, ".          -yd`        hMmd`    :MM`NMs :MNdM- NM/-MMo-MM-/y:                                     . ");
				textprintf(screen, font, 10, 220, -1, ".     `:o` :MM-   `-. .NMMM-    -MM.yMN. hMMM- dMmmNMd`y+`                                        . ");
				textprintf(screen, font, 10, 230, -1, ".     /MMy `NMo  :dNm+`NMMm-    -MMmMMMy -MMM- /NMN:+-                                            . ");
				textprintf(screen, font, 10, 240, -1, ".     .MMM+ hMh `NMMMM/+NMo     -MMMMMMM- yMM.  :+-                                               . ");
				textprintf(screen, font, 10, 250, -1, ".      mMMN:oMN`:MM/dMm yMd     -MMmy+MMh .ds`                                                    . ");
				textprintf(screen, font, 10, 260, -1, ".      yMMMm/MM:+MN -MM-/MN`    -MM:  ymy`                                                        . ");
				textprintf(screen, font, 10, 270, -1, ".      /MMMMdMMo/MM` NM+.MMo:   -MN:  ``                                                          . ");
				textprintf(screen, font, 10, 280, -1, ".      .MMhMMMMd.MM: mMo dMMh   .o:`                                                              . ");
				textprintf(screen, font, 10, 290, -1, ".       mMysMMMN`dMm/NM/ /NMm                                                                     . ");
				textprintf(screen, font, 10, 300, -1, ".       yMm`dMMM:-NMMMN`  ::`                                                                     . ");
				textprintf(screen, font, 10, 310, -1, ".       /MM..mMMo /mNm:                                                                           . ");
				textprintf(screen, font, 10, 320, -1, ".       .MM/ :NMh  `.                                                                             . ");
				textprintf(screen, font, 10, 330, -1, ".        mMy  /:`                                                                                 . ");
				textprintf(screen, font, 10, 340, -1, ".        os:                                                                                      . ");
				textprintf(screen, font, 10, 350, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 360, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 370, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 380, -1, "``````````````````````````````````````````````````````````````````````````````````````````````````` ");
			}
			clear(screen);
		}
		if(key[KEY_4])
		{
			clear(screen);
			while(!key[KEY_7])
			{
				textprintf(screen, font, 0, 0, -1,"Monster list is incomplete");
				textprintf(screen, font, 0, 10, -1,"Press 7 to go back");
				textprintf(screen, font, 10, 10, -1, "-`````````````````````````````````````````````````````````````````````````````````````````````````."); 
				textprintf(screen, font, 10, 20, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 30, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 40, -1, ".                                                                         `-                      . ");
				textprintf(screen, font, 10, 50, -1, ".                                                                        +Nd                      . ");
				textprintf(screen, font, 10, 60, -1, ".                                                                 `--    :MM`  `/o:               . ");
				textprintf(screen, font, 10, 70, -1, ".                                                                 sNh    `MM/ `dMMMs              . ");
				textprintf(screen, font, 10, 80, -1, ".                                                                 +MN`    dMs oMNyMM:             . ");
				textprintf(screen, font, 10, 90, -1, ".                                                      `:o        .MM/yd/ sMm hMs hMh             . ");
				textprintf(screen, font, 10, 100, -1, ".                                                   -o:-MM.        mMNMMM::MM.hMhyNMM`            . ");
				textprintf(screen, font, 10, 110, -1, ".                                                   hMy`NM+  -sdm/ yMMNNMd`MM/sMMNds:             . ");
				textprintf(screen, font, 10, 120, -1, ".                                                   oms hMy -NMMMN./MM//MM-dMs/MM:`+s-            . ");
				textprintf(screen, font, 10, 130, -1, ".                                                   `-/`oMN sMN/mMo.MM: NM+oMm`mMhoMM.            . ");
				textprintf(screen, font, 10, 140, -1, ".                                               `..  mM+-MM.+h+-mMd mMs hMs:MM./MMMMy             . ");
				textprintf(screen, font, 10, 150, -1, ".                               `-+/          `omNNo hMy`NM+ `+NNMM`yMN-mMy`NM/ :hy/`             . ");
				textprintf(screen, font, 10, 160, -1, ".                               :NMm`      /y:+MMNMN.oMN hMy oMm:MM:/MMNMMo hd/                   . ");
				textprintf(screen, font, 10, 170, -1, ".                               :MMMo `:s. NM:hMh.NMo-MM.oMN mMo`MMs.MMdMm. ``                    . ");
				textprintf(screen, font, 10, 180, -1, ".                       o       :MMMN``mMs mM:/+:+NMh NM+-MM-dMdyMMm`hh--.                        . ");
				textprintf(screen, font, 10, 190, -1, ".                      :N-      :MNNMs +MN.dM: .hMmMN`hMy NM++MMMsho``                            . ");
				textprintf(screen, font, 10, 200, -1, ".            `         dMo`     :MNoMN. dModM: dMh-MM:+MN hMh +h+`                                . ");
				textprintf(screen, font, 10, 210, -1, ".          -yd`        hMmd`    :MM`NMs :MNdM- NM/-MMo-MM-/y:                                     . ");
				textprintf(screen, font, 10, 220, -1, ".     `:o` :MM-   `-. .NMMM-    -MM.yMN. hMMM- dMmmNMd`y+`                                        . ");
				textprintf(screen, font, 10, 230, -1, ".     /MMy `NMo  :dNm+`NMMm-    -MMmMMMy -MMM- /NMN:+-                                            . ");
				textprintf(screen, font, 10, 240, -1, ".     .MMM+ hMh `NMMMM/+NMo     -MMMMMMM- yMM.  :+-                                               . ");
				textprintf(screen, font, 10, 250, -1, ".      mMMN:oMN`:MM/dMm yMd     -MMmy+MMh .ds`                                                    . ");
				textprintf(screen, font, 10, 260, -1, ".      yMMMm/MM:+MN -MM-/MN`    -MM:  ymy`                                                        . ");
				textprintf(screen, font, 10, 270, -1, ".      /MMMMdMMo/MM` NM+.MMo:   -MN:  ``                                                          . ");
				textprintf(screen, font, 10, 280, -1, ".      .MMhMMMMd.MM: mMo dMMh   .o:`                                                              . ");
				textprintf(screen, font, 10, 290, -1, ".       mMysMMMN`dMm/NM/ /NMm                                                                     . ");
				textprintf(screen, font, 10, 300, -1, ".       yMm`dMMM:-NMMMN`  ::`                                                                     . ");
				textprintf(screen, font, 10, 310, -1, ".       /MM..mMMo /mNm:                                                                           . ");
				textprintf(screen, font, 10, 320, -1, ".       .MM/ :NMh  `.                                                                             . ");
				textprintf(screen, font, 10, 330, -1, ".        mMy  /:`                                                                                 . ");
				textprintf(screen, font, 10, 340, -1, ".        os:                                                                                      . ");
				textprintf(screen, font, 10, 350, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 360, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 370, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 380, -1, "``````````````````````````````````````````````````````````````````````````````````````````````````` ");
			}
			clear(screen);
		}
		if(key[KEY_5])
		{
			atmenu = false;
			return;
		}
		if(key[KEY_6])
		{
			atmenu = false;
			quit = true;
			return;
		}
	}
}

void future()
{
	camerax = SCREEN_W / 2;
	cameray = SCREEN_H / 2;
	present = false; 
	ffuture = true;
	x = 2500;
	y = 3910;
	srand(time(NULL));	
	text_mode(-1);	
	load_file();
	themapweareon = 3;
	while(!quit)	
	{
		if(!atmenu)
		{
			if(last_time < current_time)
			{
				++last_time;
		     		logic();
			}
			draw();
			if(key[KEY_F1])
			{
				atmenu = true;
				menu();
			}
		 	if(key[KEY_ESC])
				quit = true;
			if(backtothepast)
			{	
				clear(screen);
				while(!key[KEY_ENTER])
				{
					textprintf(screen, font, 10, 0, -1, "You have found a rift in time that sent you back to your own time period.");
					textprintf(screen, font, 10, 10, -1, "Where you tell the people of the present about the future and how it is going to be.");
					textprintf(screen, font, 10, 20, -1, "You get kicked out of the town for talk that hobos are going to be heros.");
					textprintf(screen, font, 10, 30, -1, "Then as you are traveling you find a group of hobos and you tell them your tell.");
					textprintf(screen, font, 10, 40, -1, "They decided to join you to make sure that the future is the way you saw it.");
					textprintf(screen, font, 10, 50, -1, "Good Job!!! You've won!!! Press enter to end");						
				}
				quit = true;
				unload_file();
				return;
	 		}
	 		if(fighting)
	 		{
	 			fought = true;
	 			fightmain();
	 		}
		}	
	}
	unload_file();
	return;
}
