#include <allegro.h>
#include <fstream>
#include <iostream>
#include <cstdlib>
#include "future.h"
#include "fight.h"

using std::ifstream;

//variables
int** presentmap;
int** presentcollide;
int map_width, map_height;
int** forestmap;
int** forestcollide;
int forestmap_width, forestmap_height;
BITMAP *tilemap, *buffer, *maincharacter;
bool quit = false, standing = true, goingintothefuture = false, fighting = false, atmenu = false, fought = false, atthetitlescreen = true, battlebeforefuture = false, present = true, ffuture = false;
volatile int current_time=10;
int camerax = 0, cameray = 0, direction = 4, x = 1860, y = 640, count = 0, oldx, oldy, randomencounter, themapweareon = 1, last_time = 0;;

void timer_interrupt()
{
	++current_time;
}

void init()
{
	allegro_init();
	install_keyboard();
	install_timer();
	install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL);
	
	set_color_depth(32);
	if(set_gfx_mode(GFX_AUTODETECT_WINDOWED, 800,600,0,0) != 0)
		allegro_message("Couldn't set gfx mode!");
	
	install_int_ex(timer_interrupt,BPS_TO_TIMER(60));
	
	tilemap = load_bitmap("tilemap.bmp", NULL);
	maincharacter = load_bitmap("guy.bmp", NULL);
	buffer = create_bitmap(800, 600);
}

void load_the_file()
{
	ifstream file("present.txt");
	if(!file.good())
	{
		allegro_message("Couldn't read present.bmp");
	}
	file >> map_width >> map_height;
	
	presentmap = new int* [map_height];
	for(int i = 0; i < map_height; i++)
      presentmap[i] = new int [map_width];
   for(int y = 0; y < map_height; y++)
	{
		for(int x = 0; x < map_width; x++)
    	{
        	file >> presentmap[y][x];
      }
   }  
	 
   presentcollide = new int * [map_height];
   for(int i = 0; i < map_height; i++)
      presentcollide[i] = new int [map_width];
   for(int y = 0; y < map_height; y++)
	{
		for(int x = 0; x < map_width; x++)
    	{
        	file >> presentcollide[y][x];
      }
   }  
   
	file >> forestmap_width >> forestmap_height;
	
	forestmap = new int* [forestmap_height];
	for(int i = 0; i < forestmap_height; i++)
      forestmap[i] = new int [forestmap_width];
   for(int y = 0; y < forestmap_height; y++)
	{
		for(int x = 0; x < forestmap_width; x++)
    	{
        	file >> forestmap[y][x];
      }
   }  
	 
   forestcollide = new int * [forestmap_height];
   for(int i = 0; i < forestmap_height; i++)
      forestcollide[i] = new int [forestmap_width];
   for(int y = 0; y < forestmap_height; y++)
	{
		for(int x = 0; x < forestmap_width; x++)
    	{
        	file >> forestcollide[y][x];
      }
   }    
}

void unload_the_file()
{
	for(int i = 0; i < forestmap_height; i++)
   	delete [] forestmap[i];
	for(int i = 0; i < forestmap_height; i++)
   	delete [] forestcollide[i];
	for(int i = 0; i < map_height; i++)
   	delete [] presentmap[i];
	for(int i = 0; i < map_height; i++)
   	delete [] presentcollide[i];
}

void blit_tiles(BITMAP* to, int sx, int sy, int dx, int dy, int w, int h)
{
	if(themapweareon == 1)
	{
		int tile_left = sx / TILE_W, tile_top = sy / TILE_H;
		if(tile_left < 0)
			tile_left = 0;
		if(tile_top < 0)
			tile_top = 0;
		int tile_right = w / TILE_W + tile_left - 1, tile_bottom = h / TILE_H + tile_top + 1;
		if(tile_right > map_width)
			tile_right = map_width;
		if(tile_bottom > map_height)
			tile_bottom = map_height;
		sx = -sx + tile_left * TILE_W + dx;
		sy = -sy + tile_top * TILE_H + dy;	
		for(int y = tile_top; y < tile_bottom; y++, sy += TILE_H)
		{
			for(int x = tile_left, temp_sx = sx; x < tile_right; x++, temp_sx += TILE_W)
			{
					blit(tilemap, to, (presentmap[y][x] % 10) * TILE_W, presentmap[y][x] / 10 * TILE_H, temp_sx, sy, TILE_W, TILE_H);
			}
		}
	}
	if(themapweareon == 2)
	{
		int tile_left = sx / TILE_W, tile_top = sy / TILE_H;
		if(tile_left < 0)
			tile_left = 0;
		if(tile_top < 0)
			tile_top = 0;
		int tile_right = w / TILE_W + tile_left - 1, tile_bottom = h / TILE_H + tile_top + 1;
		if(tile_right > forestmap_width)
			tile_right = forestmap_width;
		if(tile_bottom > forestmap_height)
			tile_bottom = forestmap_height;
		sx = -sx + tile_left * TILE_W + dx;
		sy = -sy + tile_top * TILE_H + dy;	
		for(int y = tile_top; y < tile_bottom; y++, sy += TILE_H)
		{
			for(int x = tile_left, temp_sx = sx; x < tile_right; x++, temp_sx += TILE_W)
			{
					blit(tilemap, to, (forestmap[y][x] % 10) * TILE_W, forestmap[y][x] / 10 * TILE_H, temp_sx, sy, TILE_W, TILE_H);
			}
		}
	}
}

void draw()
{
	int tlx = camerax - SCREEN_W / 2, tly = cameray - SCREEN_H / 2;
	clear(buffer);
	blit_tiles(buffer, tlx, tly, 0, 0, SCREEN_W + 32, SCREEN_H + 32);
	blit_tiles(buffer, tlx, tly, 0, 0, SCREEN_W + 64, SCREEN_H + 32);
	if(standing)
	{
		switch(direction)
		{
			case 4: masked_blit(maincharacter, buffer, 29, 104, x - tlx, y - tly, 15, 24); break;
			case 6: masked_blit(maincharacter, buffer, 29, 40, x - tlx, y - tly, 15, 24); break;
			case 8: masked_blit(maincharacter, buffer, 28, 8, x - tlx,  y - tly, 16, 24); break;
			default: masked_blit(maincharacter, buffer, 28, 72, x - tlx, y - tly, 16, 24); break;
		}
	}
	else switch(direction)
	{
		case 4:
			switch(count / 6 % 3)
			{
				case 0: masked_blit(maincharacter, buffer, 4, 104, x - tlx, y - tly, 15, 24); break;
				case 1: masked_blit(maincharacter, buffer, 29, 104, x - tlx, y - tly, 15, 24); break;
				case 2: masked_blit(maincharacter, buffer, 53, 104, x - tlx, y - tly, 15, 24); break;
			}
			break;
		case 6:
			switch(count / 6 % 3)
			{
				case 0: masked_blit(maincharacter, buffer, 4, 40, x - tlx, y - tly, 15, 24); break;
				case 1: masked_blit(maincharacter, buffer, 29, 40, x - tlx, y - tly, 15, 24); break;
				case 2: masked_blit(maincharacter, buffer, 53, 40, x - tlx, y - tly, 15, 24); break;
				}
			break;
		case 8:
			switch(count / 6 % 3)
			{
				case 0: masked_blit(maincharacter, buffer, 4, 8, x - tlx, y - tly, 15, 24); break;
				case 1: masked_blit(maincharacter, buffer, 28, 8, x - tlx,  y - tly, 16, 24); break;
				case 2: masked_blit(maincharacter, buffer, 53, 8, x - tlx, y - tly, 15, 24); break;
			}
			break;
		default:
			switch(count / 6 % 3)
			{
				case 0: masked_blit(maincharacter, buffer, 4, 72, x - tlx, y - tly, 15, 24); break;
				case 1: masked_blit(maincharacter, buffer, 28, 72, x - tlx, y - tly, 16, 24); break;
				case 2: masked_blit(maincharacter, buffer, 53, 72, x - tlx, y - tly, 15, 24); break;
			}
			break;
	}
	vsync();
	blit(buffer, screen, 0, 0, 0, 0, 800, 600);
}

void logic()
{
	while(!key[KEY_ENTER] && atthetitlescreen)
	{
		textprintf(screen, font, 10, 0, -1, "hhhhdmmddmmdddmmmmdhhhhyyyyyhddddmddhhhhhhyyhhhyyyyyyyyyhhhhhhhhhhhyyyhhhhddhhddddmdmddhmmdmmdmmmmmN");
		textprintf(screen, font, 10, 10, -1, "ddhhhddhhdddhdddhhhhhhhhhhhhhhhhhhhhhhhyyyssyyhhhhhhhhhyhhhhhhhyssyyyhddddhhhhddddddddddddddddmmmmmN");
		textprintf(screen, font, 10, 20, -1, "mmdmmdddhhhhhhhhhdmmmdhhhdhhhyyhyyyssyyyhhhhhhhhhhhhhhhhhhhhhhhhyhhhhhhdddddddmmmmmmmmddddmmmmNNNNNN");
		textprintf(screen, font, 10, 30, -1, "Nmddddhhhhhdddddmmmddhhhyyyyhdddhyyyyyyyhhhhyyyyhhhhddmddddddmmdddddddmmdddddhdddhhddmdddddmmdmmmmmd");
		textprintf(screen, font, 10, 40, -1, "mmdhdmmddmmmmmdhhhdddhhdhhhhhhhhhhhhhhyyhhhhyyyyyhhyhhddyyyddddhhhdddhhhhdmmmdhyysso++o++osyyssoyyss");
		textprintf(screen, font, 10, 50, -1, "ddhhhhhddddddhhhdhhhhyyyyhhhhhhhhhhhhhhhhhhyyyyyyyhyyhhhhysyhhyso+++o+o++ossyo/::---:://///+o+++ssoo");
		textprintf(screen, font, 10, 60, -1, "hhyhhhhhddhhhhhyyyyyyyyyyhhhhhhhyyyhhhyyyyyyssyyyyhyo///:----..`````....-::::::::::://+ooossyhyyyhyy");
		textprintf(screen, font, 10, 70, -1, "hhhyhhyhdhhyyyyysyyyyyyyyyyyyyyyyyyyyyyyyhyyssyyys+--:/o.``````````...---:::/+////++++oooossyyyyhyyy");
		textprintf(screen, font, 10, 80, -1, "ddhhhhhddhhhhhyyyyhhhhhyyhyyhhhhhhhhhhhhyhhhyyhy+-..-:/+-..```````..--::::://++++++++o+ossyossssssys");
		textprintf(screen, font, 10, 90, -1, "mmmdddddhhhhhyyyyyhyhhyyyyyhhyyhhhhyyyyyyhhhyys:.`.-:::-....`.`...-:/::///::///+o++++oososooso+oooos");
		textprintf(screen, font, 10, 100, -1, "mddddhhyyyyyyyyyyyyyyysssssyyysyyyyyssssyyyys:..```..............-://////::::::////+//+oooo+oo++++oo");
		textprintf(screen, font, 10, 110, -1, "ddhdhhhhhhyyhyyysssyyyysysyyyyyyyyyhhysyhhhhs...`````....`......://o+o+/+::----:////://+++/+/++/++o+");
		textprintf(screen, font, 10, 120, -1, "dhhhhyhhhyssssyyssssyyyyyyyysssyhyyhyyyyyyhh+/--.```.--.``````.-:/+oos+++::----:::::::///++++/+++/++");
		textprintf(screen, font, 10, 130, -1, "yhhyyhhhhysyysyyyssyyssyyhhhhyyyyyyyyhddddho/---.```....````...-///ooo++++/::--::::://+/+//+++++/::/");
		textprintf(screen, font, 10, 140, -1, "syhyyyyhhhyhhhhhhhhyhyyhhhhhhhhhhhhhhhddhy/:.--:-...-:--..--:--://+/+oo+o/+::::////////++ooo++//:///");
		textprintf(screen, font, 10, 150, -1, "ddhhdhhhddddhhdddhhhhhhhdddhddddhhhdhhys/:-:://sso+/-:::-:++/::/++/:+/+++++/+////+::///++oso+///://+");
		textprintf(screen, font, 10, 160, -1, "ddhhhdddddddhhhhhhhhddhhdhhddhhdhhyhhyo+:-::///o+sys+/+/+++++/:///////+o+/ss++:/:/:://///++++///:/++");
		textprintf(screen, font, 10, 170, -1, "ddhdhhhhhyhhhhhddddddddyyyyhddhhhyyyo:-:::::////+ooyyyyyso++++/+//:://+///++++/:/+:::://+++++////o+o");
		textprintf(screen, font, 10, 180, -1, "dyshhyhddhhddhdhyhhhhhhyhhdhyhhyyyho:..-:::////++oosdmmmmyo+/++//+:////////:::///+://:/++ooo++++o+oy");
		textprintf(screen, font, 10, 190, -1, "dhhhhhhddddddddhyhhddhhhhddhyhhhhho:----::://////soshysydhhhyoo+///o+//////:::::/:::///ossyysso+/ohm");
		textprintf(screen, font, 10, 200, -1, "ddddhhddhhdddhhhhddhhhhhddhhhddmho::///+/++/::-:/oyys//ososdmhhhysosso/::::::/:::::--::/osydmhyo+yhd");
		textprintf(screen, font, 10, 210, -1, "dhhddyhddddhdhhhyyhhhhyhddhhyhdho//++ssssos/:::::+syo//os+oydhyyhyhhhyys++::/++o:------:oyddmddhhddm");
		textprintf(screen, font, 10, 220, -1, "ddddmdmmddhyyyyhhyhhhhhyhhhhhyho:/+ossssssho/:://oydhssoydddhyyyhyhhdddyyyysssyhs:-----/ymddmdhdmddm");
		textprintf(screen, font, 10, 230, -1, "mdhdmmmdhhyyhhdhhhhddhdhhhhhhho/+soyyyyss/o+:::/+yhhhdmdmdhyysyshhhhdddddhdddyhdms:---:+sdhmmmhdhyhd");
		textprintf(screen, font, 10, 240, -1, "ddddddddddhddmmmmmddhyhddmmmhssyyhssyhyyy/+/:++oshdyyhdhhyhhyhssydhhyhdhhyyds+osyh::--:odmmdmmmmddhd");
		textprintf(screen, font, 10, 250, -1, "dmmmdddmmddddmhdmdddhddhdmddddmmdmmdddmdh/+::/+syhdhhdhhhyhyhyyhhddhddhyhhhy::/+sy+::-:ommNNmmmdmddm");
		textprintf(screen, font, 10, 260, -1, "ddddddddddhydhhmmNmmddhyhhymmmmmmmddmhmmyo+//:+hmmmhhhhhyddhhhyyyhddhdddddd+--:/sho---:smNmmmmmmmNNm");
		textprintf(screen, font, 10, 270, -1, "hddmdddhhdddmdmmmmmmdddhddmmmmmmmdddddmmhss//:oddhdhyhyyshyyhyhyyhdddhmmmmy---:odmh.--:odmmmmmmmmNNm");
		textprintf(screen, font, 10, 280, -1, "dddmmddmmmNmmdmmmmNmmmmmddmmmmNmdmdhhdddddhoo//yyhhhyhyyyhhhhhhhhmmmmddmmm:.-:+ymNm.--:+dNNNNNNNNNNN");
		textprintf(screen, font, 10, 290, -1, "mmdmmmmmmmNmdmmddmmmmmmmdmmmdmmmddhhhhddhdhhys+ohyhhhdhhddmmhddmdmmmNmNNNs.-//oddNN:--:/ohNNNNNNNNNN");
		textprintf(screen, font, 10, 300, -1, "ddhdmmmNNmmNmdmhmmmmdmmmmmmmmmmdhhyyyyhyhdhhyydhdddddmNmmmdmmNmmmNNNNNNNy--://ohmNNh+/::/+odmNNNNNNN");
		textprintf(screen, font, 10, 310, -1, "dmmdmdmmmdmdhddydddhdhhddhhhhddhhdhhhhyyhhhhhdhhdmmNNmNNNNNNmmmmdmNmNNd+--/+soydNNNNmho//:/ohdmmmmNN");
		textprintf(screen, font, 10, 320, -1, "hhhhhhdhhhhhhddhdmdddhdddddddmddmmdddhdhydddmdddhhhdddmmmmmmddmddys+o+://+shNdhNNNNNNNmdyo+/ommyyhhh");
		textprintf(screen, font, 10, 330, -1, "hhddddhhdhdddhmmdmhmmddmddmddmhmmdmmmddmmmdhmhdhyhhhhyosshhhhyyysoooyyyhyhhmNmmNNNNmmmddhhyhyhdmNddd");
		textprintf(screen, font, 10, 340, -1, "ddhhhhddhhmddhdmdmddmddmmdmmdmdhdmmddhddhddhsshhhyyyhyyhdhmdmddhdmdmmdmmmmmdmmmdmmdmmmNdmmmmddshmNNm");
		textprintf(screen, font, 10, 350, -1, "ddmmmdhdhdmddhdmmyyddddddhdmmyyhddddmmdddhhdhyyyyyyshhddyhmdmdmdhmddddhhmNNmmdddddddmmmdhddhyshdhmmm");
		textprintf(screen, font, 10, 360, -1, "hyhddhhhhhdmmmhmmddhddddmmhmmdddhddddhhddhhyhyhhhhhhhyyyyhddhddhmmmmmdmdmNmdhdmddddmmmdmmmddhhysyyhd");
		textprintf(screen, font, 10, 370, -1, "hyhhhhhddhhhhhhhhhyyyhyyhhhhhhyhdddhhyydhhddhdhhhhhyhhysoosyyyhhdyshhdddddmmNNNdmmmmdhhdhhhhdhdhdmmd");
		textprintf(screen, font, 350, 500, -1,"Press enter to start");
		textprintf(screen, font, 350, 510, -1,"Press H for help");
		if(key[KEY_H])
		{
			rest(150);
			clear(screen);
			while(!key[KEY_H])
			{
				textprintf(screen, font, 0, 0, -1,"Left Arrow = go left");
				textprintf(screen, font, 0, 10, -1,"Right Arrow = go right");
				textprintf(screen, font, 0, 20, -1,"Up Arrow = go up");
				textprintf(screen, font, 0, 30, -1,"Down Arrow = go down");
				textprintf(screen, font, 0, 40, -1,"Enter is used for");
				textprintf(screen, font, 0, 50, -1,"F1 is used to enter the menu");
				textprintf(screen, font, 0, 60, -1,"Press H to go back to title screen");				
			}
			clear(screen);
			rest(150);
		}
	}
	
	atthetitlescreen = false;
	{
		if(key[KEY_LEFT])
		{
			x -= 5;
			standing = false;
			count ++;
			direction = 4;
			if(themapweareon == 1)
			{
				if(presentcollide[y / TILE_H][x / TILE_W] == 8)
				{
					x = 3166;
					y = 220;
				}
				if(presentcollide[y / TILE_H][x / TILE_W] == 1 || presentcollide[(y + 24) / TILE_H][x / TILE_W] == 1 )
					x = oldx;
			}		
			if(themapweareon == 2)
			{
				if(forestcollide[y / TILE_H][x / TILE_W] == 1 || forestcollide[(y + 24) / TILE_H][x / TILE_W] == 1 )
					x = oldx;
				if(forestcollide[y / TILE_H][x / TILE_W] == 4) 
				{
					battlebeforefuture = true;
				}
				if(forestcollide[y / TILE_H][x / TILE_W] == 3)
				{
					themapweareon = 1;
					x = 2500;
					y = 2334;
					return;
				}
			}
			else if(count % 5 == 0)
			{	
				randomencounter =  (rand() % 50) + 1;
				if(randomencounter == 42)
				{
					fighting = true;
				}
			}
		}
		else if(key[KEY_RIGHT])
		{
			x += 5;
			standing = false;
			count ++;
			direction = 6;
			if(themapweareon == 1)
			{
				if(presentcollide[y / TILE_H][x / TILE_W] == 3) 
				{
					themapweareon = 2;
			  		y = 320;
			  		x = 34;
			  		return;
			  	}
				if(presentcollide[y / TILE_H][x / TILE_W] == 5)
				{
					x = 32;
					y = 2320;
				}
				
				if(presentcollide[y / TILE_H][(x + 16) / TILE_W] == 1 || presentcollide[(y + 24) / TILE_H][(x + 16) / TILE_W] == 1)
					x = oldx;
			}		
			if(themapweareon == 2)
			{
				if(forestcollide[y / TILE_H][(x + 16) / TILE_W] == 1 || forestcollide[(y + 24) / TILE_H][(x + 16) / TILE_W] == 1 )
					x = oldx;
				if(forestcollide[y / TILE_H][x / TILE_W] == 4) 
				{
					battlebeforefuture = true;
				}
				if(forestcollide[y /TILE_H][(x + 16) / TILE_W] == 5)
				{
					x = 34;
					y = 320;
				}
			}
			else if(count % 5 == 0)
			{	
				randomencounter =  (rand() % 50) + 1;
				if(randomencounter == 42)
				{
					fighting = true;
				}
			}
		}
		else if(key[KEY_UP])
		{
			y -= 5;
			standing = false;
			count ++;
			direction = 8;
			if(themapweareon == 1)
			{
				if(presentcollide[y / TILE_H][x / TILE_W] == 6)
				{
					y= 3136;
					x = 624;
				}
				if(presentcollide[y / TILE_H][(x + 16) / TILE_W] == 1 || presentcollide[y / TILE_H][x / TILE_W] == 1)
					y = oldy;
			}		
			if(themapweareon == 2)
			{
				if(forestcollide[y / TILE_H][x / TILE_W] == 1 || forestcollide[y / TILE_H][(x + 16) / TILE_W] == 1 )
					x = oldx;
				if(forestcollide[y / TILE_H][x / TILE_W] == 4) 
				{
					battlebeforefuture = true;
				}
			}
			else if(count % 5 == 0)
			{	
				randomencounter =  (rand() % 50) + 1;
				if(randomencounter == 42)
				{
					fighting = true;
				}
			}
		}
		else if(key[KEY_DOWN])
		{
			y += 5;
			standing = false;
			count ++;
			direction = 2;
			if(themapweareon == 1)
			{
				if(presentcollide[y / TILE_H][x / TILE_W] == 7)
				{
					x = 604;
					y = 34;
				}
				if(presentcollide[(y + 24) / TILE_H][x / TILE_W] == 1 || presentcollide[(y + 24) / TILE_H][(x + 16) / TILE_W] == 1)
					y = oldy;
			}		
			if(themapweareon == 2)
			{
				if(forestcollide[(y + 24) / TILE_H][(x + 16) / TILE_W] == 1 || forestcollide[(y + 24) / TILE_H][x / TILE_W] == 1 )
					y = oldy;
				if(forestcollide[y / TILE_H][x / TILE_W] == 4) 
				{
					battlebeforefuture = true;
				}
			}
			else if(count % 5 == 0)
			{	
				randomencounter = (rand() % 50) + 1;
				if(randomencounter == 42)
				{
					fighting = true;
				}
			}
		}
		else
		{
			standing = true;
			count = 0;
		}
		oldx = x;
		oldy = y;
		camerax = x;
		cameray = y;
	}
}

void menu()
{
	clear(screen);
	while(atmenu)
	{
		textprintf(screen, font, 0,  0, -1,"1. Items");
		textprintf(screen, font, 0, 10, -1,"2. Status");
		textprintf(screen, font, 0, 20, -1,"3. Equipment");
		textprintf(screen, font, 0, 30, -1,"4. Monster List");
		textprintf(screen, font, 0, 40, -1,"5. Back to Game");
		textprintf(screen, font, 0, 50, -1,"6. Exit Game");
		textprintf(screen, font, 0, 60, -1,"Press 7 to go back from any sub-menu");
		if(key[KEY_1])
		{
			clear(screen);
			while(!key[KEY_7])
			{
				textprintf(screen, font, 0, 0, -1,"Items is incomplete");
				textprintf(screen, font, 0, 10, -1,"Press 7 to go back");
				textprintf(screen, font, 10, 10, -1, "-`````````````````````````````````````````````````````````````````````````````````````````````````."); 
				textprintf(screen, font, 10, 20, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 30, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 40, -1, ".                                                                         `-                      . ");
				textprintf(screen, font, 10, 50, -1, ".                                                                        +Nd                      . ");
				textprintf(screen, font, 10, 60, -1, ".                                                                 `--    :MM`  `/o:               . ");
				textprintf(screen, font, 10, 70, -1, ".                                                                 sNh    `MM/ `dMMMs              . ");
				textprintf(screen, font, 10, 80, -1, ".                                                                 +MN`    dMs oMNyMM:             . ");
				textprintf(screen, font, 10, 90, -1, ".                                                      `:o        .MM/yd/ sMm hMs hMh             . ");
				textprintf(screen, font, 10, 100, -1, ".                                                   -o:-MM.        mMNMMM::MM.hMhyNMM`            . ");
				textprintf(screen, font, 10, 110, -1, ".                                                   hMy`NM+  -sdm/ yMMNNMd`MM/sMMNds:             . ");
				textprintf(screen, font, 10, 120, -1, ".                                                   oms hMy -NMMMN./MM//MM-dMs/MM:`+s-            . ");
				textprintf(screen, font, 10, 130, -1, ".                                                   `-/`oMN sMN/mMo.MM: NM+oMm`mMhoMM.            . ");
				textprintf(screen, font, 10, 140, -1, ".                                               `..  mM+-MM.+h+-mMd mMs hMs:MM./MMMMy             . ");
				textprintf(screen, font, 10, 150, -1, ".                               `-+/          `omNNo hMy`NM+ `+NNMM`yMN-mMy`NM/ :hy/`             . ");
				textprintf(screen, font, 10, 160, -1, ".                               :NMm`      /y:+MMNMN.oMN hMy oMm:MM:/MMNMMo hd/                   . ");
				textprintf(screen, font, 10, 170, -1, ".                               :MMMo `:s. NM:hMh.NMo-MM.oMN mMo`MMs.MMdMm. ``                    . ");
				textprintf(screen, font, 10, 180, -1, ".                       o       :MMMN``mMs mM:/+:+NMh NM+-MM-dMdyMMm`hh--.                        . ");
				textprintf(screen, font, 10, 190, -1, ".                      :N-      :MNNMs +MN.dM: .hMmMN`hMy NM++MMMsho``                            . ");
				textprintf(screen, font, 10, 200, -1, ".            `         dMo`     :MNoMN. dModM: dMh-MM:+MN hMh +h+`                                . ");
				textprintf(screen, font, 10, 210, -1, ".          -yd`        hMmd`    :MM`NMs :MNdM- NM/-MMo-MM-/y:                                     . ");
				textprintf(screen, font, 10, 220, -1, ".     `:o` :MM-   `-. .NMMM-    -MM.yMN. hMMM- dMmmNMd`y+`                                        . ");
				textprintf(screen, font, 10, 230, -1, ".     /MMy `NMo  :dNm+`NMMm-    -MMmMMMy -MMM- /NMN:+-                                            . ");
				textprintf(screen, font, 10, 240, -1, ".     .MMM+ hMh `NMMMM/+NMo     -MMMMMMM- yMM.  :+-                                               . ");
				textprintf(screen, font, 10, 250, -1, ".      mMMN:oMN`:MM/dMm yMd     -MMmy+MMh .ds`                                                    . ");
				textprintf(screen, font, 10, 260, -1, ".      yMMMm/MM:+MN -MM-/MN`    -MM:  ymy`                                                        . ");
				textprintf(screen, font, 10, 270, -1, ".      /MMMMdMMo/MM` NM+.MMo:   -MN:  ``                                                          . ");
				textprintf(screen, font, 10, 280, -1, ".      .MMhMMMMd.MM: mMo dMMh   .o:`                                                              . ");
				textprintf(screen, font, 10, 290, -1, ".       mMysMMMN`dMm/NM/ /NMm                                                                     . ");
				textprintf(screen, font, 10, 300, -1, ".       yMm`dMMM:-NMMMN`  ::`                                                                     . ");
				textprintf(screen, font, 10, 310, -1, ".       /MM..mMMo /mNm:                                                                           . ");
				textprintf(screen, font, 10, 320, -1, ".       .MM/ :NMh  `.                                                                             . ");
				textprintf(screen, font, 10, 330, -1, ".        mMy  /:`                                                                                 . ");
				textprintf(screen, font, 10, 340, -1, ".        os:                                                                                      . ");
				textprintf(screen, font, 10, 350, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 360, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 370, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 380, -1, "``````````````````````````````````````````````````````````````````````````````````````````````````` ");
			}
			clear(screen);
		}
		if(key[KEY_2])
		{
			clear(screen);
			while(!key[KEY_7])
			{
				masked_blit(maincharacter, screen, 28, 72, 0, 0, 16, 24);
				textprintf(screen, font, 0, 30, -1,"Name: Christopher");
				textprintf(screen, font, 0, 40, -1,"Level: %d", level);
				if(!fought)
					textprintf(screen, font, 0, 50, -1,"Hp: You'll find out after your first battle. Okay?");
				if(fought)
					textprintf(screen, font, 0, 50, -1,"Hp: %d", hp);
				textprintf(screen, font, 0, 60, -1,"Hometown: Unknown");
				textprintf(screen, font, 0, 70, -1,"Age: Old");
				textprintf(screen, font, 0, 80, -1,"Occupation: Hobo");
				textprintf(screen, font, 0, 90, -1,"Likes: Food, money, women, and sleep");
				textprintf(screen, font, 0, 100, -1,"Dislikes: People who ignore him, not getting any sleep, and being poor");
				textprintf(screen, font, 0, 110, -1,"Bio:Not much know about his youth. Travels the world in search of riches.");				
			}
			clear(screen);
		}
		if(key[KEY_3])
		{
			clear(screen);
			while(!key[KEY_7])
			{
				textprintf(screen, font, 0, 0, -1,"Can't have equipment without items, eh?");
				textprintf(screen, font, 0, 10, -1,"Press 7 to go back");
				textprintf(screen, font, 10, 10, -1, "-`````````````````````````````````````````````````````````````````````````````````````````````````."); 
				textprintf(screen, font, 10, 20, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 30, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 40, -1, ".                                                                         `-                      . ");
				textprintf(screen, font, 10, 50, -1, ".                                                                        +Nd                      . ");
				textprintf(screen, font, 10, 60, -1, ".                                                                 `--    :MM`  `/o:               . ");
				textprintf(screen, font, 10, 70, -1, ".                                                                 sNh    `MM/ `dMMMs              . ");
				textprintf(screen, font, 10, 80, -1, ".                                                                 +MN`    dMs oMNyMM:             . ");
				textprintf(screen, font, 10, 90, -1, ".                                                      `:o        .MM/yd/ sMm hMs hMh             . ");
				textprintf(screen, font, 10, 100, -1, ".                                                   -o:-MM.        mMNMMM::MM.hMhyNMM`            . ");
				textprintf(screen, font, 10, 110, -1, ".                                                   hMy`NM+  -sdm/ yMMNNMd`MM/sMMNds:             . ");
				textprintf(screen, font, 10, 120, -1, ".                                                   oms hMy -NMMMN./MM//MM-dMs/MM:`+s-            . ");
				textprintf(screen, font, 10, 130, -1, ".                                                   `-/`oMN sMN/mMo.MM: NM+oMm`mMhoMM.            . ");
				textprintf(screen, font, 10, 140, -1, ".                                               `..  mM+-MM.+h+-mMd mMs hMs:MM./MMMMy             . ");
				textprintf(screen, font, 10, 150, -1, ".                               `-+/          `omNNo hMy`NM+ `+NNMM`yMN-mMy`NM/ :hy/`             . ");
				textprintf(screen, font, 10, 160, -1, ".                               :NMm`      /y:+MMNMN.oMN hMy oMm:MM:/MMNMMo hd/                   . ");
				textprintf(screen, font, 10, 170, -1, ".                               :MMMo `:s. NM:hMh.NMo-MM.oMN mMo`MMs.MMdMm. ``                    . ");
				textprintf(screen, font, 10, 180, -1, ".                       o       :MMMN``mMs mM:/+:+NMh NM+-MM-dMdyMMm`hh--.                        . ");
				textprintf(screen, font, 10, 190, -1, ".                      :N-      :MNNMs +MN.dM: .hMmMN`hMy NM++MMMsho``                            . ");
				textprintf(screen, font, 10, 200, -1, ".            `         dMo`     :MNoMN. dModM: dMh-MM:+MN hMh +h+`                                . ");
				textprintf(screen, font, 10, 210, -1, ".          -yd`        hMmd`    :MM`NMs :MNdM- NM/-MMo-MM-/y:                                     . ");
				textprintf(screen, font, 10, 220, -1, ".     `:o` :MM-   `-. .NMMM-    -MM.yMN. hMMM- dMmmNMd`y+`                                        . ");
				textprintf(screen, font, 10, 230, -1, ".     /MMy `NMo  :dNm+`NMMm-    -MMmMMMy -MMM- /NMN:+-                                            . ");
				textprintf(screen, font, 10, 240, -1, ".     .MMM+ hMh `NMMMM/+NMo     -MMMMMMM- yMM.  :+-                                               . ");
				textprintf(screen, font, 10, 250, -1, ".      mMMN:oMN`:MM/dMm yMd     -MMmy+MMh .ds`                                                    . ");
				textprintf(screen, font, 10, 260, -1, ".      yMMMm/MM:+MN -MM-/MN`    -MM:  ymy`                                                        . ");
				textprintf(screen, font, 10, 270, -1, ".      /MMMMdMMo/MM` NM+.MMo:   -MN:  ``                                                          . ");
				textprintf(screen, font, 10, 280, -1, ".      .MMhMMMMd.MM: mMo dMMh   .o:`                                                              . ");
				textprintf(screen, font, 10, 290, -1, ".       mMysMMMN`dMm/NM/ /NMm                                                                     . ");
				textprintf(screen, font, 10, 300, -1, ".       yMm`dMMM:-NMMMN`  ::`                                                                     . ");
				textprintf(screen, font, 10, 310, -1, ".       /MM..mMMo /mNm:                                                                           . ");
				textprintf(screen, font, 10, 320, -1, ".       .MM/ :NMh  `.                                                                             . ");
				textprintf(screen, font, 10, 330, -1, ".        mMy  /:`                                                                                 . ");
				textprintf(screen, font, 10, 340, -1, ".        os:                                                                                      . ");
				textprintf(screen, font, 10, 350, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 360, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 370, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 380, -1, "``````````````````````````````````````````````````````````````````````````````````````````````````` ");
			}
			clear(screen);
		}
		if(key[KEY_4])
		{
			clear(screen);
			while(!key[KEY_7])
			{
				textprintf(screen, font, 0, 0, -1,"Monster list is incomplete");
				textprintf(screen, font, 0, 10, -1,"Press 7 to go back");
				textprintf(screen, font, 10, 10, -1, "-`````````````````````````````````````````````````````````````````````````````````````````````````."); 
				textprintf(screen, font, 10, 20, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 30, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 40, -1, ".                                                                         `-                      . ");
				textprintf(screen, font, 10, 50, -1, ".                                                                        +Nd                      . ");
				textprintf(screen, font, 10, 60, -1, ".                                                                 `--    :MM`  `/o:               . ");
				textprintf(screen, font, 10, 70, -1, ".                                                                 sNh    `MM/ `dMMMs              . ");
				textprintf(screen, font, 10, 80, -1, ".                                                                 +MN`    dMs oMNyMM:             . ");
				textprintf(screen, font, 10, 90, -1, ".                                                      `:o        .MM/yd/ sMm hMs hMh             . ");
				textprintf(screen, font, 10, 100, -1, ".                                                   -o:-MM.        mMNMMM::MM.hMhyNMM`            . ");
				textprintf(screen, font, 10, 110, -1, ".                                                   hMy`NM+  -sdm/ yMMNNMd`MM/sMMNds:             . ");
				textprintf(screen, font, 10, 120, -1, ".                                                   oms hMy -NMMMN./MM//MM-dMs/MM:`+s-            . ");
				textprintf(screen, font, 10, 130, -1, ".                                                   `-/`oMN sMN/mMo.MM: NM+oMm`mMhoMM.            . ");
				textprintf(screen, font, 10, 140, -1, ".                                               `..  mM+-MM.+h+-mMd mMs hMs:MM./MMMMy             . ");
				textprintf(screen, font, 10, 150, -1, ".                               `-+/          `omNNo hMy`NM+ `+NNMM`yMN-mMy`NM/ :hy/`             . ");
				textprintf(screen, font, 10, 160, -1, ".                               :NMm`      /y:+MMNMN.oMN hMy oMm:MM:/MMNMMo hd/                   . ");
				textprintf(screen, font, 10, 170, -1, ".                               :MMMo `:s. NM:hMh.NMo-MM.oMN mMo`MMs.MMdMm. ``                    . ");
				textprintf(screen, font, 10, 180, -1, ".                       o       :MMMN``mMs mM:/+:+NMh NM+-MM-dMdyMMm`hh--.                        . ");
				textprintf(screen, font, 10, 190, -1, ".                      :N-      :MNNMs +MN.dM: .hMmMN`hMy NM++MMMsho``                            . ");
				textprintf(screen, font, 10, 200, -1, ".            `         dMo`     :MNoMN. dModM: dMh-MM:+MN hMh +h+`                                . ");
				textprintf(screen, font, 10, 210, -1, ".          -yd`        hMmd`    :MM`NMs :MNdM- NM/-MMo-MM-/y:                                     . ");
				textprintf(screen, font, 10, 220, -1, ".     `:o` :MM-   `-. .NMMM-    -MM.yMN. hMMM- dMmmNMd`y+`                                        . ");
				textprintf(screen, font, 10, 230, -1, ".     /MMy `NMo  :dNm+`NMMm-    -MMmMMMy -MMM- /NMN:+-                                            . ");
				textprintf(screen, font, 10, 240, -1, ".     .MMM+ hMh `NMMMM/+NMo     -MMMMMMM- yMM.  :+-                                               . ");
				textprintf(screen, font, 10, 250, -1, ".      mMMN:oMN`:MM/dMm yMd     -MMmy+MMh .ds`                                                    . ");
				textprintf(screen, font, 10, 260, -1, ".      yMMMm/MM:+MN -MM-/MN`    -MM:  ymy`                                                        . ");
				textprintf(screen, font, 10, 270, -1, ".      /MMMMdMMo/MM` NM+.MMo:   -MN:  ``                                                          . ");
				textprintf(screen, font, 10, 280, -1, ".      .MMhMMMMd.MM: mMo dMMh   .o:`                                                              . ");
				textprintf(screen, font, 10, 290, -1, ".       mMysMMMN`dMm/NM/ /NMm                                                                     . ");
				textprintf(screen, font, 10, 300, -1, ".       yMm`dMMM:-NMMMN`  ::`                                                                     . ");
				textprintf(screen, font, 10, 310, -1, ".       /MM..mMMo /mNm:                                                                           . ");
				textprintf(screen, font, 10, 320, -1, ".       .MM/ :NMh  `.                                                                             . ");
				textprintf(screen, font, 10, 330, -1, ".        mMy  /:`                                                                                 . ");
				textprintf(screen, font, 10, 340, -1, ".        os:                                                                                      . ");
				textprintf(screen, font, 10, 350, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 360, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 370, -1, ".                                                                                                 . ");
				textprintf(screen, font, 10, 380, -1, "``````````````````````````````````````````````````````````````````````````````````````````````````` ");
			}
			clear(screen);
		}
		if(key[KEY_5])
		{
			atmenu = false;
			return;
		}
		if(key[KEY_6])
		{
			atmenu = false;
			quit = true;
			return;
		}
	}
}

int main()
{
	init();
	srand(time(NULL));	
	text_mode(-1);	
	load_the_file();
	while(!quit)
	{
		if(!atmenu)
		{
			if(last_time < current_time)
			{
		     	logic();
				++last_time;
					logic();
			}
			draw();
			if(key[KEY_ESC])
			{
				quit = true;
			}
			if(key[KEY_F1])
			{
				atmenu = true;
				menu();
			}
			if(battlebeforefuture)
			{
				clear(screen);
				while(!key[KEY_ENTER])
				{
					textprintf(screen, font, 10, 0, -1, "You have been sent foward in time to a place filled with sex, drugs, and war.");
					textprintf(screen, font, 10, 10, -1, "A time where hobos are heros. Press Enter");
				}
				battlebeforefuture = false;
				unload_the_file();
	 			future();
	 		}
	 		if(fighting)
	 		{
	 			fought = true;
	 			fightmain();
	 		}
	 	}
 	}
 	
	return 0;
}

END_OF_MAIN()
